#! /usr/bin/python

import sys
import threading
import os
import time
from scapy.all import *
from optparse import OptionParser
from random import randint

"""
Author: Demetris Papapetrou and QSecure
Creation Date: one day in 2010
Release Date: 25/09/2014
Purpose: Proof of Concept (PoC) tool for performing idle scans using IP, TCP, UDP, ICMP packets.
		 Scans can be performed with the help of idle or moderately busy zombie hosts or routers.
Dependencies: Scapy network packet generator

Comments: I know that my programming skills suck :-)

License
--------
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
"""

# Turn down the verbosity of scapy
conf.verb = 0

 
def set_parse_options():

	parser = OptionParser(usage="usage: %prog [options] target:port")
	parser.add_option("-z", dest="zombie",
                  help="IP address of zombie host (mandatory)" )
	parser.add_option("-T", dest="tcp",
                  help="use TCP to communicate with the zombie. Available flags S/A/F/U/P/R" )
	parser.add_option("-U", dest="udp", action="store_true",
                  help="use UDP to communicate with the zombie" )
	parser.add_option("-I", dest="icmp",
                  help="use ICMP to communicate with the zombie P=Ping (default) T=Timestamp A=Address Mask" )
	parser.add_option("-P",dest="ip", action="store_true",
                  help="use IP Protocol to communicate with the zombie" )
	parser.add_option("-t",dest="tcp_port",
                  help="TCP port to use when communicating with the zombie" )
	parser.add_option("-u",dest="udp_port",
                  help="UDP port to use when communicating with the zombie" )
	parser.add_option("-p",dest="ip_proto",
                  help="IP protocol number to use when communicating with the zombie")
	parser.add_option("--ttl", dest="ttl",
                  help="how many hops the packet will traverse")
	parser.add_option("-c", dest="packet_count",
                  help="number of packets to send to zombie host")
	parser.add_option("-b", dest="burst",
                  help="number of packets to send to the target as a quick burst")
	parser.add_option("--fast", dest="fast", action="store_true",
                  help="send zombie probes faster than 1pps" )
	
	

	parser.set_defaults(tcp = None,
		udp = False,
		icmp = None,
		ip = False,
		ip_proto = 16,
		packet_count = 2,
		ttl = 128,
		burst = 1,
		fast = False)

	return parser


class ScanTarget ( threading.Thread ):

   # Override Thread's __init__ method to accept the parameters needed:
   def __init__ ( self, spoofed_host, target_ip, tcp_sport, target_port, burst ):

      self.spoofed_host = spoofed_host
      self.target_ip = target_ip
      self.tcp_sport = tcp_sport
      self.target_port = target_port
      self.burst = burst
      threading.Thread.__init__ ( self )

   def run ( self ):
	send([IP(src=spoofed_host,dst=target_ip,id=RandShort())/TCP(sport=tcp_sport,dport=target_port,flags="S")] * burst)
	#cmd = "hping2 -q -I eth1 -c "+ str(burst) + " --fast -S -a " + spoofed_host + " -s " + str(tcp_sport) + " -p " + str(target_port) + " " + target_ip
	#os.system(cmd)

if __name__ == "__main__":

	parser = set_parse_options()
	(option, args) = parser.parse_args()
	
	#### Section for checking the validity of program parameters ####
	if len(args) != 1:
		parser.print_help()
        	parser.error("incorrect number of arguments")
		sys.exit(2)
		
	try:
		if option.zombie: 
			zombie = str(option.zombie)
	except:
		parser.print_help()
		parser.error("zombie host must be an IP address")
	
	try:
		if option.packet_count: 
			count = int(option.packet_count)
	except:
		parser.print_help()
		parser.error("Packet count must be an integer")
		
	try:
		if option.burst: 
			burst = int(option.burst)
	except:
		parser.print_help()
		parser.error("Packet burst must be an integer > 0")
	
	try:
		if option.tcp: 
			tcp = str(option.tcp)
	except:
		parser.print_help()
		parser.error("TCP scan mode must contain one or more of the flags S/A/F/P/U/R")
	
	try:
		if option.icmp: 
			icmp = str(option.icmp)
	except:
		parser.print_help()
		parser.error("ICMP scan mode must contain one of the following option P/T/A")
	
	try:
		if option.tcp_port: 
			tcp_port = int(option.tcp_port)
	except:
		parser.print_help()
		parser.error("TCP port must be an integer")
		
	try:
		if option.udp_port: 
			udp_port = int(option.udp_port)
	except:
		parser.print_help()
		parser.error("UDP port must be an integer")
	
	try:
		if option.ip_proto: 
			ip_proto = int(option.ip_proto)
	except:
		parser.print_help()
		parser.error("IP proto must be an integer < 255")
	
	try:
		if option.ttl: 
			ip_ttl = int(option.ttl)
	except:
		parser.print_help()
		parser.error("TTL value must be an integer < 255")
	
	
	#Check packet count 
	if count < 2:
		parser.print_help()
		parser.error("Error: Packet count must be at least 2")
		sys.exit(2)
	
	#Check burst number 
	if burst < 1:
		parser.print_help()
		parser.error("Error: Packet burst must be an integer > 0")
		sys.exit(2)
		
	#Check TCP port
	if option.tcp_port:
		tcp_port = int(option.tcp_port)
	else:
		tcp_port = 80
	tcp_sport = tcp_port
	
	#Check UDP port
	if option.udp_port:
		udp_port = int(option.udp_port)
	else:
		udp_port = 80
	udp_sport = udp_port
	
	#### PARAMETER CHECK ####
	if count >= 256:
		print "count must be an integer < 256"
		sys.exit(2)
	
	if tcp_port >= 65536 or udp_port >= 65536:
		print "UDP/TCP ports must be an integer < 65536"
		sys.exit(2)
	
	if ip_proto >= 255:
		print "IP proto must be an integer < 255"
		sys.exit(2)
	
	if ip_ttl >= 255:
		print "TTL value must be an integer < 255"
		sys.exit(2)

	#Check if only the allowed flags can be set for TCP scanning
	if option.tcp != None and tcp.find("S") ==-1 and tcp.find("A") ==-1 and tcp.find("F") ==-1 and tcp.find("P") ==-1 and tcp.find("U") ==-1 and tcp.find("R") ==-1:
		parser.print_help()
		parser.error("TCP scan mode must contain one or more of the flags S/A/F/P/U/R")
		sys.exit(2)
	
	#Check if only the allowed options can be set for ICMP scanning
	if option.icmp != None and icmp.find("P") ==-1 and icmp.find("T") ==-1 and icmp.find("A") ==-1:
		parser.print_help()
		parser.error("ICMP scan mode must contain one of the following option P/T/A")
		sys.exit(2)	
	
	#If no scan mode is defined default to ICMP	
	if option.tcp == None and option.udp == False and option.icmp == None and option.ip == False:
		option.icmp = "P"
		icmp = "P"
	
	#Separate Target's IP from Port number
	if args[0]:
		target = str(args[0])
		if target.find(":") != -1:
			target_list = target.split(":",1)
			target_ip = str(target_list[0])
			target_port = str(target_list[1])
			if target_ip.find(":") != -1 or target_port.find(":") != -1:
				print "Error: Target IP and port must be separated by a single colon (:)"
				sys.exit(2)
			else:
				target_port = int(target_port)
				if target_port > 65535:
					print "Error: Target port must be an integer < 65536"
					sys.ext(2)
		else:
			target_ip = target
			target_port = 80
		
	#Check that zombie IP is defined
	if option.zombie == None:	
		print "Error: A zombie host IP must be defined. use -z <zombie_IP> "
		sys.exit(2)
	
	
	print "Scan process initiated..."
	##########  TCP  ##########
	try:
		#TCP Syn scan
		if option.tcp != None:
			previousID = 0
			for i in range(count):
				if option.fast != True:
					time.sleep(1)
				ans,unans = sr(IP(dst=zombie,id=RandShort(),ttl=ip_ttl)/TCP(sport=RandShort(),dport=tcp_port,flags=tcp),timeout=2)
				for s,r in ans:
					if r.haslayer(IP):
						if previousID == 0: previousID = r[IP].id
						if r.haslayer(TCP):
							if s[TCP].dport == r[TCP].sport:
								print "TCP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID)
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 11 and r.getlayer(ICMP).code == 0:
							print "TCP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_TTL_Exceeded)"
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 3:
							print "TCP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Unreachable)"
						elif r.haslayer(ICMP):
							print "TCP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Other)"
						spoofed_host = r[IP].src
						previousID = r[IP].id
				for s in unans:
					print "TCP: No Response"
					sys.exit(1)
				if i == (count / 2) - 1:
					print "TCP: sending " + str(burst) + " spoofed packet(s)..."
					#wrpcap("/tmp/test.cap",pcap_pkt)
					#sendpfast(Ether(dst="00:17:08:35:78:AB")/IP(src=spoofed_host,dst=target_ip,id=RandShort())/TCP(sport=tcp_sport,dport=target_port,flags="S"),iface="eth1")
					#send([IP(src=spoofed_host,dst=target_ip,id=RandShort())/TCP(sport=tcp_sport,dport=target_port,flags="S")] * burst)
					ScanTarget ( spoofed_host, target_ip, tcp_sport, target_port, burst ).start()
			print "----------------------------------------------------------------------"	
		
		##########  UDP  ##########
		if option.udp == True:  
			#UDP scan
			previousID = 0
			for i in range(count):
				if option.fast != True:
					time.sleep(1)
				ans,unans = sr(IP(dst=zombie,id=RandShort(),ttl=ip_ttl)/UDP(sport=RandShort(),dport=udp_port),timeout=2)
				for s,r in ans:
					if r.haslayer(IP):
						if previousID == 0: previousID = r[IP].id
						if r.haslayer(ICMP) and r.getlayer(ICMP).type == 3:
							print "UDP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Unreachable)"
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 11 and r.getlayer(ICMP).code == 0:
							print "UDP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_TTL_Exceeded)"
						elif r.haslayer(ICMP):
							print "UDP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Other)"
						spoofed_host = r[IP].src
						previousID = r[IP].id	
				for s in unans:
					print "UDP: No Response. Try to find a closed port."
					sys.exit(1)
				if i == (count / 2) - 1:
					print "UDP: sending " + str(burst) + " spoofed packet(s)..."
					ScanTarget ( spoofed_host, target_ip, RandShort(), target_port, burst ).start()
			print "----------------------------------------------------------------------"	
		
		##########  ICMP  ##########
		if option.icmp != None:
			previousID = 0
			for i in range(count):
				if option.fast != True:
					time.sleep(1)
				#ICMP ping scan
				if icmp.find("P") >= 0 and icmp.find("T") == -1 and icmp.find("A") == -1:
					ans,unans = sr(IP(dst=zombie,id=RandShort(),ttl=ip_ttl)/ICMP(type=8,code=0),timeout=2)
				#ICMP timestamp scan
				elif icmp.find("P") == -1 and icmp.find("T") >= 0 and icmp.find("A") == -1:
					ans,unans = sr(IP(dst=zombie,id=RandShort(),ttl=ip_ttl)/ICMP(type=13,code=0),timeout=2)
				#ICMP address mask scan
				elif icmp.find("P") == -1 and icmp.find("T") == -1 and icmp.find("A") >= 0:
					ans,unans = sr(IP(dst=zombie,id=RandShort(),ttl=ip_ttl)/ICMP(type=17,code=0),timeout=2)
				else:
					print "Error: You can only use one of the ICMP options"
					sys.exit(2)
					
				for s,r in ans:
					if r.haslayer(IP):
						if previousID == 0: previousID = r[IP].id
						if r.haslayer(ICMP) and r.getlayer(ICMP).type == 0:
							print "ICMP Ping:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID)
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 14:
							print "ICMP Timestamp:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID)
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 18:
							print "ICMP Address Mask:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID)
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 11 and r.getlayer(ICMP).code == 0:
							print "ICMP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_TTL_Exceeded)"
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 3:
							print "ICMP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Unreachable)"
						elif r.haslayer(ICMP):
							print "ICMP:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Other)"
						spoofed_host = r[IP].src
						previousID = r[IP].id
				for s in unans:
					print "ICMP: No Response"
					sys.exit(1)
				if i == (count / 2) - 1:
					print "ICMP: sending " + str(burst) + " spoofed packet(s)..."
					ScanTarget ( spoofed_host, target_ip, RandShort(), target_port, burst ).start()
			print "----------------------------------------------------------------------"		
					
		##########  IP  ##########
		if option.ip == True:
			#IP protocol scan
			previousID = 0
			for i in range(count):
				if option.fast != True:
					time.sleep(1)
				ans,unans = sr(IP(dst=zombie,id=RandShort(),proto=ip_proto,ttl=ip_ttl)/"PIZZA",timeout=2)
				for s,r in ans:
					if r.haslayer(IP):
						if previousID == 0: previousID = r[IP].id
						if r.haslayer(ICMP) and r.getlayer(ICMP).type == 11 and r.getlayer(ICMP).code == 0:
							print "IP Protocol:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_TTL_Exceeded)"
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 3 and r.getlayer(ICMP).code == 2:
							print "IP Protocol:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Proto-Unreach)"
						elif r.haslayer(ICMP) and r.getlayer(ICMP).type == 3:
							print "IP Protocol:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Unreachable)"
						elif r.haslayer(ICMP):
							print "IP Protocol:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	(ICMP_Other)"
						else:
							print "IP Protocol:  ip=" + r[IP].src + " 	id=" + str(r[IP].id) + " 	inc=" + str(r[IP].id - previousID) + " 	proto=" + str(r[IP].proto)
						spoofed_host = r[IP].src
						previousID = r[IP].id	
							
				for s in unans:
					print "IP Protocol: No Response"
					sys.exit(1)
				if i == (count / 2) - 1:
					print "IP Protocol: sending " + str(burst) + " spoofed packet(s)..."
					ScanTarget ( spoofed_host, target_ip, RandShort(), target_port, burst ).start()
			print "----------------------------------------------------------------------"			
	except KeyboardInterrupt:
		print "Operation interrupted by the user..."
		sys.exit(1)
